#!/usr/local/bin/jperl5


&main();
exit(0);

sub main () {
    my $infile = $ARGV[0];
    my $outfile = $ARGV[1];
    my @sen =(); 
    my $paren_left  = '\[\{\(';
    my $paren_right = '\]\}\)';
    my $paren_both  = '\[\]\{\}\(\)';
    
    print STDERR "separate one sentence...";

    open(IN, $infile) || die "$infile : $!\n";
    open(OUT, ">$outfile") || die "$outfile : $!\n";
#԰ʸ...
    while(<IN>){
	chomp;
    
	# Υԥꥪɤѥԥꥪɤˤ¸
	my $flag = s/(\d)\.(\d)/$1$2/g;
    
	# Ѵսѥڡˡ
	s/\.(?=[\sA-Z](?!\.,?))/\./g;
    
	foreach(split(//, $_)){
	    s/^\s+//;     # ˤĤƤ롢פʥڡ롣
	    s/\s+$//;
	    next if $_ eq '';
      
	    # Ѥˤԥꥪɤ᤹
	    s//\./g if $flag;
      
	    push(@sen,$_);
	}
    
    } 
    print STDERR "done.\n";
    print STDERR "tokenize.....";
    #tokenize
    foreach(@sen){
	chomp;
	s/^\"/`` /g;
	s/($paren_left)\"/$1 `` /og;
	# ԥꥪɤǤǤʸʬ򤵤ƤΤǡʸΥԥꥪɤоݤˤ롥
	s/([\.\!\?]+)$/ $1/;          # write a letter. -> write a letter .
	s/([\,\@\#\$\%\^\&\*\_\+\=\-\;\:\~])/ $1 /g;
	
	# Assume sentence tokenization has been done first, so split FINAL periods
	# only. 
	s/([^\.])(\.)([$paren_right\"\']*)\s*$/$1 $2 $3 /og;
	
	# parentheses, brackets, etc.
	s/([$paren_both])/ $1 /og;
	
	s/--/ -- /g;
	s/\"/ \'\' /g;
	
	# possessive or close-single-quote
	s/([^\'])\' /$1 \' /g;
	
	# as in it's, I'm, we'd
	s/\'([sSmMdD]) / \'$1 /g;
	s/\'ll / \'ll /g;
	s/\'re / \'re /g;
	s/\'ve / \'ve /g;
	s/n\'t / n\'t /g;
	s/\'LL / \'LL /g;
	s/\'RE / \'RE /g;
	s/\'VE / \'VE /g;
	s/N\'T / N\'T /g;
	s/ ([Cc])annot / $1an not /g;
	s/ ([Dd])\'ye / $1\' ye /g;
	s/ ([Gg])imme / $1im me /g;
	s/ ([Gg])onna / $1on na /g;
	s/ ([Gg])otta / $1ot ta /g;
	s/ ([Ll])emme / $1em me /g;
	s/ ([Mm])ore\'n / $1ore \'n /g;
	s/ \'([Tt])is / \'$1 is /g;
	s/ \'([Tt])was / \'$1 was /g;
	s/ ([Ww])anna / $1an na /g;
	# s/ ([Ww])haddya / $1ha dd ya /g;
	# s/ ([Ww])hatcha / $1ha t cha /g;
	
	# clean out extra spaces
	s/\s\s+/ /g;
	s/^\s+//;
	s/\s+$//;
	
	print OUT $_, "\n";
	



    }
  
    print STDERR "done.\n";

sub _num_form($;){
    $_ = shift;
    s/(\S+)[\_\^\+]([\w\(\)\[\]\*+]+)/suusiki/g;
    s/(suusiki[\_\^\-\+]?\s)+[\_\^\-\+]?suusiki/suusiki/g;
  
    $_;
}

close(OUT);
close(IN);

}


